#include<iostream>
#include<algorithm>
#include<vector>
#define endl '\n'
using namespace std;
int n,a[100005],nbr,nom[100005];
vector<int> tree[400002];
void build(int node,int l,int r)
{
    if(l==r)
    {
        tree[node].push_back(a[l]);
        return;
    }
    int mid=(l+r)/2;

    build(2*node,l,mid);
    build(2*node+1,mid+1,r);

    tree[node]=tree[2*node];
    for(int i=0;i<tree[2*node+1].size();i++)
        tree[node].push_back(tree[2*node+1][i]);

    sort(tree[node].begin(),tree[node].end());
}
int query(int node,int l,int r,int le,int ri,int num,bool bigger)
{
    if(tree[node].size()==0) return 0;

    if(l>=le && r<=ri)
    {
        int il=0,ir=tree[node].size()-1,mid;

        if(bigger)
        {
            while(il<=ir)
            {
                mid=(il+ir)/2;

                if(tree[node][mid]<num)
                    il=mid+1;
                else
                    ir=mid-1;
            }

            return il;
        }
        else
        {
            while(il<=ir)
            {
                mid=(il+ir)/2;

                if(tree[node][mid]<num)
                    il=mid+1;
                else
                    ir=mid-1;
            }

            return il;
        }
    }
    if(l>ri || r<le) return 0;

    int mid=(l+r)/2;

    return query(2*node,l,mid,le,ri,num,bigger)+query(2*node+1,mid+1,r,le,ri,num,bigger);
}
void update(int node,int l,int r,int nm)
{
    if(l>nm || r<nm || tree[node].size()==0) return;
    if(l==r)
    {
        tree[node].erase(tree[node].begin());
        return;
    }
    int mid=(l+r)/2;

    update(2*node,l,mid,nm);
    update(2*node+1,mid+1,r,nm);

    tree[node]=tree[2*node];
    for(int i=0;i<tree[2*node+1].size();i++)
        tree[node].push_back(tree[2*node+1][i]);

    sort(tree[node].begin(),tree[node].end());
}
int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n;

    nbr=0;
    for(int i=1;i<=n;i++)
    {
        cin>>a[i];
        nom[a[i]]=i;
    }
    build(1,1,n);

    for(int i=2;i<=n;i++)
    {
        nbr+=query(1,1,n,1,i-1,a[i],1);
    }
    cout<<nbr<<endl;

    int ch;
    for(int i=1;i<n-1;i++)
    {
        cin>>ch;
        nbr-=query(1,1,n,1,nom[ch]-1,ch,1);
        nbr-=query(1,1,n,nom[ch]+1,n,ch,0);

        update(1,1,n,nom[ch]);

        cout<<nbr<<endl;
    }
}
