#pragma GCC optimize("O3")
#pragma GCC target("avx512f")
#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>

struct BIT {
    int n;
    std::vector<int> data;

    BIT(int n = 0) {
        this->n = n;
        data.assign(n, 0);
    }

    void update(int i, int dlt) {
        for (; i < n; i |= i + 1) {
            data[i] += dlt;
        }
    }

    int get(int i) {
        int res = 0;
        for (; i >= 0; i = (i & (i + 1)) - 1) {
            res += data[i];
        }
        return res;
    }
};

template <typename T>
using ordered_set = __gnu_pbds::tree<T, __gnu_pbds::null_type, std::less<T>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

struct FUCK {
    int n;
    std::vector<ordered_set<std::pair<int, int>>> vec;

    FUCK(int n = 0) : n(n), vec(n) {
        ;
    }

    void insert(int i, int val) {
        int p = i;
        for (; i < n; i |= i + 1) {
            vec[i].insert({val, p});
        }
    }

    void erase(int i, int val) {
        int p = i;
        for (; i < n; i |= i + 1) {
            vec[i].erase({val, p});
        }
    }

    inline int get_le(const ordered_set<std::pair<int, int>>& set, int val) {
        int res = set.order_of_key({val + 1, -1});
        return res;
    }

    int get_le(int i, int val) {
        int res = 0;
        for (; i >= 0; i = ((i + 1) & i) - 1) {
            res += get_le(vec[i], val);
        }
        return res;
    }

    inline int get_gt(const ordered_set<std::pair<int, int>>& set, int val) {
        int res = set.order_of_key({val + 1, -1});
        res = set.size() - res;
        return res;
    }

    int get_gt(int i, int val) {
        int res = 0;
        for (; i >= 0; i = ((i + 1) & i) - 1) {
            res += get_gt(vec[i], val);
        }
        return res;
    }
};

int64_t count_inv(std::vector<int> input) {
    int n = input.size();

    BIT bt(n);
    int64_t res = 0;
    for (int i = 0; i < n; i++) {
        res += i - bt.get(input[i]);
        bt.update(input[i], 1);
    }
    return res;
}

std::mt19937 rnd;

int32_t main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);

#ifdef LOCAL
#define CUM
#endif

    int n;
    n = 1e5;
#ifndef CUM
    std::cin >> n;
#endif
    std::vector<int> input(n);
    std::iota(input.begin(), input.end(), 0);
    std::shuffle(input.begin(), input.end(), rnd);
    for (int& i : input) {
#ifndef CUM
        std::cin >> i;
        i--;
#endif
    }
    std::vector<int> pos(n);
    for (int i = 0; i < n; i++) {
        pos[input[i]] = i;
    }
    std::vector<int> quer(n - 2);
    std::iota(quer.begin(), quer.end(), 0);
    std::shuffle(quer.begin(), quer.end(), rnd);

    for (int& i : quer) {
#ifndef CUM
        std::cin >> i;
        i--;
#endif
    }

    int64_t inv = 0;
    inv = count_inv(input);

    return 0;

    FUCK fuck(n);
    for (int i = 0; i < n; i++) {
        fuck.insert(i, input[i]);
    }

    std::cout << inv << " ";
    for (int i = 0; i < n - 2; i++) {
        int dlt = 0;
        int q = quer[i];
        int p = pos[q];

        dlt += fuck.get_gt(p, q);

        dlt += fuck.get_le(n - 1, q) - fuck.get_le(p, q);

        fuck.erase(p, q);
        inv -= dlt;
        std::cout << inv << " \n"[i == n - 3];
    }

    return 0;
}
