// #pragma GCC optimize("O3")
#pragma GCC target("avx512f,bmi,bmi2,lzcnt")
#include <bits/stdc++.h>
#include <immintrin.h>

#include <ext/pb_ds/assoc_container.hpp>

struct BIT {
    int n;
    std::vector<int> data;

    inline int hole(int i) {
        return i + (i >> 10);
    }

    BIT(int n = 0, bool fill = false) {
        this->n = n;
        data.assign(hole(n + 1), 0);
        if (fill) {
            for (int i = 0; i < n; i++) {
                data[hole(i)] = i - ((i & (i + 1)) - 1);
            }
        }
    }

    inline void update(int i, int dlt) {
        for (; i < n; i |= i + 1) {
            data[hole(i)] += dlt;
        }
    }

    inline int get(int i) {
        int res = 0;
        for (; i >= 0; i = (i & (i + 1)) - 1) {
            res += data[hole(i)];
        }
        return res;
    }
};

constexpr int inf = 1e9;
constexpr int B = 16;

uint32_t lower_bound_epi32(__m512i vec, __m512i val) {
    uint32_t mask = _mm512_cmpgt_epi32_mask(val, vec);
    return __tzcnt_u32(~mask);
}

struct FUCK {
    std::vector<std::vector<int>> fuck;
    int sz, dp;
    const int* data;

    std::vector<const int*> cum;

    FUCK() {
        ;
    }

    FUCK(const std::vector<int>& vec) {
        sz = vec.size();
        data = vec.data();
        dp = 0;

        for (int k = 4; (1 << k) < sz; k += 4) {
            fuck.push_back({});
            for (int i = 0; i < sz; i += (1 << k)) {
                fuck.back().push_back(data[i]);
            }
            while (fuck.back().size() % 16) {
                fuck.back().push_back(inf);
            }
            cum.push_back(fuck.back().data());
        }
        cum.push_back(data);
        dp = cum.size();
    }

    int lower_bound(__m512i val) {
        if (sz == 0) {
            return 0;
        }
        int pos = 0;
        for (int i = 0; i < dp; i++) {
            pos = pos * 16;
            __m512i vec = _mm512_loadu_epi32(cum[i] + pos);
            int lb = lower_bound_epi32(vec, val);
            pos += lb;
        }
        return pos;
    }
};

struct SHIT {
    std::vector<std::vector<int>> data;
    std::vector<BIT> bit;
    std::vector<FUCK> fuck;
    int size;

    SHIT(std::vector<int> input) {
        int n = input.size();
        size = 1 << 32 - __builtin_clz(std::max(1, n - 1));
        data.assign(size * 2, {});
        bit.assign(size * 2, BIT());

        for (int i = 0; i < n; i++) {
            data[size + i] = {input[i]};
        }
        for (int i = size - 1; i > 0; i--) {
            data[i].resize(data[2 * i].size() + data[2 * i + 1].size());
            std::merge(data[2 * i + 1].begin(), data[2 * i + 1].end(), data[2 * i].begin(), data[2 * i].end(), data[i].begin());
        }

        for (int i = 0; i < 2 * size; i++) {
            bit[i] = BIT(data[i].size(), true);
        }
        fuck.resize(2 * size);
        for (int i = 0; i < 2 * size; i++) {
            while (data[i].size() % 16) {
                data[i].push_back(inf);
            }
            fuck[i] = FUCK(data[i]);
        }
    }

    [[gnu::noinline]] inline int lb(int i, __m512i val) {
        int it = fuck[i].lower_bound(val);
        // int it2 = std::lower_bound(data[i].begin(), data[i].end(), _mm_cvtsi128_si32(_mm512_castsi512_si128(val))) - data[i].begin();
        // int itx = fuck[i].lower_bound(val);
        // assert(it == it2);

        return it;
    }

    inline void update(int i, int val, int dlt) {
        __m512i vec = _mm512_set1_epi32(val);
        i += size;
        for (; i > 0; i >>= 1) {
            bit[i].update(lb(i, vec), dlt);
        }
    }

    inline int get_le(int i, __m512i val) {
        int res = bit[i].get(lb(i, val) - 1);
        return res;
    }

    [[gnu::noinline]] int get_le(int l, int r, int val) {
        __m512i vec = _mm512_set1_epi32(val + 1);

        int res = 0;
        for (l += size, r += size; l < r; l >>= 1, r >>= 1) {
            if (l & 1) {
                res += get_le(l++, vec);
            }
            if (r & 1) {
                res += get_le(--r, vec);
            }
        }
        return res;
    }
};

int64_t count_inv(std::vector<int> input) {
    int n = input.size();

    BIT bt(n);
    int64_t res = 0;
    for (int i = 0; i < n; i++) {
        res += i - bt.get(input[i]);
        bt.update(input[i], 1);
    }
    return res;
}

std::mt19937 rnd;

int32_t main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);

#ifdef LOCAL
// #define CUM
#endif

    int n;
    n = 1e5;
#ifndef CUM
    std::cin >> n;
#endif
    std::vector<int> input(n);
#ifdef CUM
    std::iota(input.begin(), input.end(), 0);
    std::shuffle(input.begin(), input.end(), rnd);
#endif
    for (int& i : input) {
#ifndef CUM
        std::cin >> i;
        i--;
#endif
    }
    std::vector<int> pos(n);
    for (int i = 0; i < n; i++) {
        pos[input[i]] = i;
    }
    std::vector<int> quer(n - 2);
#ifdef CUM
    std::iota(quer.begin(), quer.end(), 0);
    std::shuffle(quer.begin(), quer.end(), rnd);
#endif
    for (int& i : quer) {
#ifndef CUM
        std::cin >> i;
        i--;
#endif
    }

    int64_t inv = 0;
    inv = count_inv(input);

    BIT bt(n, true);
    SHIT shit(input);
    for (int i = 0; i < n; i++) {
        // shit.update(i, input[i], 1);
        // bt.update(i, 1);
    }

    std::cout << inv << " ";
    for (int i = 0; i < n - 2; i++) {
        int dlt = 0;
        int q = quer[i];
        int p = pos[q];

        shit.update(p, q, -1);
        bt.update(p, -1);

        dlt += bt.get(p) - shit.get_le(0, p, q);
        dlt += shit.get_le(p + 1, shit.size, q);

        inv -= dlt;
        std::cout << inv << " \n"[i == n - 3];
    }

    return 0;
}
