#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define ll long long
#define ve vector
#define pb push_back
#define all(x)   	(x).begin(),(x).end()
#define sz(x) 		(int)((x).size())
using namespace std;
using namespace __gnu_pbds;
using oset = tree<int,null_type,less<int>,rb_tree_tag,tree_order_statistics_node_update>;

const int N = 1e5 + 10;
ve<int> que[N];
ve<int> f[N];

inline void add(int x, int y) {
	x += 2;
	for (; x < N; x += x & -x) que[x].pb(y);
}
inline void build() {
	for (int i = 0; i < N; ++i) {
		sort(all(que[i]));
		que[i].erase(unique(all(que[i])), que[i].end());
		int s = sz(que[i]);
		f[i].resize(s + 7);
	}
}
inline void upd(int x, int y, int d) {
	x += 2;
	for (; x < N; x += x & -x) {
		int i = lower_bound(all(que[x]), y) - que[x].begin() + 2;
		for (; i < sz(f[x]); i += i & -i) f[x][i] += d;
	}
}
inline int get(int x, int y) {
	if (x < 0 || y < 0) return 0;

	x += 2;
	int ans = 0;
	for (; x; x -= x & -x) {
		int i = upper_bound(all(que[x]), y) - que[x].begin() - 1;
		i += 2;
		for (; i; i -= i & -i) ans += f[x][i];
	}
	return ans;
}

inline int get(int x, int y, int x1, int y1) {
	if (x > x1 || y > y1) return 0;
	return get(x1, y1) - get(x - 1, y1) - get(x1, y - 1) + get(x - 1, y - 1);
}

signed main() {
	ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

	int n;
	cin >> n;
	vector<int> a(n);
	for (auto &i : a) cin >> i;

	vector<int> ps(n + 1);
	for (int i = 0; i < n; ++i) ps[a[i]] = i;

	ll ans = 0;
	oset st;
	for (int i = n - 1; ~i; --i) {
		ans += st.order_of_key(a[i]);
		st.insert(a[i]);

		add( i, a[i] );
	}
	build();
	for (int i = 0; i < n; ++i) upd(i, a[i], +1);

	cout << ans << " ";

	for (int i = 0; i < n - 2; ++i) {
		int x;
		cin >> x;
		int p = ps[x];

		ans -= get(0, x, p - 1, n);
		ans -= get(p + 1, 0, n - 1, x - 1);
		upd(p, x, -1);

		cout << ans << " ";
	}
}
