#include <bits/stdc++.h>

#pragma GCC optimize("O3")

using namespace std;

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
template <typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#define fbo find_by_order
#define ook order_of_key

const int N = 1e5 + 5;

#define ve vector
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()

int n;
int a[N];

int pos[N];
//oset<int> t[N];
ve<int> u[N];
int cnt[N];
ve<int> t[N];

void add1(int pos, int x) {
    while (pos <= n) {
        u[pos].pb(x);
        pos = pos | (pos + 1);
    }
}

void add(int pos, int x) {
    while (pos <= n) {

        int p = lower_bound(all(u[pos]), x) - u[pos].begin();
        while (p < sz(u[pos])) {
            t[pos][p]++;
            p = p | (p + 1);
        }
        cnt[pos]++;

        pos = pos | (pos + 1);
    }
}

void del(int pos, int x) {
    while (pos <= n) {

        int p = lower_bound(all(u[pos]), x) - u[pos].begin();
        while (p < sz(u[pos])) {
            t[pos][p]--;
            p = p | (p + 1);
        }
        cnt[pos]--;

        pos = pos | (pos + 1);
    }
}

int get(ve<int>& t, int p) {
    int sum = 0;
    while (p >= 0) {
        sum += t[p];
        p = (p & (p + 1)) - 1;
    }
    return sum;
}

int getGreater(int pos, int x) {
    int ans = 0;
    while (pos >= 0) {
        int p = upper_bound(all(u[pos]), x) - u[pos].begin() - 1;
        ans += cnt[pos] - get(t[pos], p);

        pos = (pos & (pos + 1)) - 1;
    }
    return ans;
}

int getLess(int pos, int x) {
    int ans = 0;
    while (pos >= 0) {
        int p = upper_bound(all(u[pos]), x) - u[pos].begin() - 1;
        ans += get(t[pos], p);

        pos = (pos & (pos + 1)) - 1;
    }
    return ans;
}

int T[N];

void inc(int p) {
    while (p <= n) {
        T[p]++;
//        cout << p << " " << n << "\n";
        p = p | (p + 1);
    }
}

int calc(int p) {
    int ans = 0;
    while (p >= 0) {
        ans += T[p];
        p = (p & (p + 1)) - 1;
    }
    return ans;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cin >> n;
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        pos[a[i]] = i;
    }

//    oset<int> s;
    long long ans = 0;
    for (int i = 1; i <= n; i++) {
        ans += i - 1 - calc(a[i]);
//        s.insert(a[i]);
        inc(a[i]);
    }

    cout << ans << " ";

    for (int i = 1; i <= n; i++) {
        add1(pos[i], i);
    }
    for (int i = 0; i <= n; i++) {
        t[i].resize(sz(u[i]));
    }

    for (int i = 1; i <= n; i++) {
        add(pos[i], i);
    }

    for (int i = 1; i < n - 1; i++) {
        int x;
        cin >> x;
        ans -= getGreater(pos[x] - 1, x);
        ans -= getLess(n, x) - getLess(pos[x], x);

        del(pos[x], x);

        cout << ans;
        if (i + 1 < n) cout << " ";
        else cout << "\n";
    }

    return 0;
}
