#include <bits/stdc++.h>
#define int long long
#define sz size()
#define vint vector<int>

using namespace std;

vector<vector<int> > tree(400040);
int num[400040];
int a[400040];

void build(int v, int l, int r)
{
    if(l == r)
    {
        tree[v].push_back(a[l]);
        return;
    }
    int m = (l + r) / 2;
    build(v * 2, l, m);
    build(v * 2 + 1, m + 1, r);
   // tree[v] = tree[v * 2];
    merge(tree[v * 2].begin(), tree[v * 2].end(), tree[v * 2 + 1].begin(), tree[v * 2 + 1].end(), back_inserter(tree[v]));
    sort(tree[v].begin(), tree[v].end());
}

pair<int, int> gett(int v, int l, int r, int ll, int rr, int x)
{
    if(ll > r || rr < l)
    {
        return {0, 0};
    }
    if(ll >= l && rr <= r)
    {
        int k = upper_bound(tree[v].begin(), tree[v].end(), x) - tree[v].begin();
        pair<int, int> ret;
        ret.first = k;
        ret.second = tree[v].size() - k - num[v];
        return ret;
    }
    int m = (ll + rr) / 2;
    pair<int, int> p1 = gett(v * 2, l, r, ll, m, x);
    pair<int, int> p2 = gett(v * 2 + 1, l, r, m + 1, rr, x);
    p1.first += p2.first;
    p1.second += p2.second;
    return p1;
}

void del(int v, int l, int r, int i, int x)
{
    if(l == r && l == i)
    {
        tree[v][0] = LLONG_MAX;
        num[v] = 1;
        return;
    }
    int m = (l + r) / 2;
    if(i <= m)
        del(v * 2, l, m, i, x);
    else
        del(v * 2 + 1, m + 1, r, i, x);
    num[v] ++;
   // tree[v] = tree[v * 2];
    tree[v].clear();
    merge(tree[v * 2].begin(), tree[v * 2].end(), tree[v * 2 + 1].begin(), tree[v * 2 + 1].end(), back_inserter(tree[v]));
    sort(tree[v].begin(), tree[v].end());
}
int32_t main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vint pos(n + 1);
    int ans = 0;
    for(int i = 0; i < n; i ++)
    {
        cin >> a[i];
        pos[a[i]] = i;
    }
    build(1, 0, n - 1);
    for(int i = 1; i < n; i ++)
    {
        pair<int, int> k = gett(1, 0, i - 1, 0, n - 1, a[i]);
        ans += k.second;
    }
    cout << ans;
    for(int kk = 1; kk <= n - 2; kk ++)
    {
        int t;
        cin >> t;
        int p = pos[t];
        pair<int, int> k = gett(1, 0, p - 1, 0, n - 1, a[p]);
        ans -= k.second;
        k = gett(1, p + 1, n - 1, 0, n - 1, a[p]);
        ans -= k.first;
        del(1, 0, n - 1, p, t);
        a[p] = -1;
        cout << " " << ans;
    }
}
