#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

template <typename T>
using oset = tree <T, null_type, less <T>, rb_tree_tag, tree_order_statistics_node_update>;


int n;
int a[1000000];
oset <int> st[1000000];

long long ans = 0;

void add(int x, int ps) {
    while(ps < n) {
        st[ps].insert(x);
        ps = (ps|(ps + 1));
    }
}
void del(int x, int ps) {
    while(ps < n) {
        st[ps].erase(x);
        ps = (ps|(ps + 1));
    }
}


int gt_mr(int x, int ps) {
    int ans = 0;
    while(ps >= 0) {
        ans += st[ps].size() - st[ps].order_of_key(x + 1);
        ps = (ps&(ps + 1)) - 1;
    }
    return ans;
}

int gt_ls(int x, int ps) {
    int ans = 0;
    while(ps >= 0) {
        ans += st[ps].order_of_key(x);
        ps = (ps&(ps + 1)) - 1;
    }
    return ans;
}
int pos[1000000];

int main() {

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL

    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        pos[a[i]] = i;
        add(a[i], i);
        ans += gt_mr(a[i], i);
    }
    cout << ans << " ";
    for(int i = 0; i < n - 2; i++) {
        int x;
        cin >> x;
        x = pos[x];
        ans -= gt_mr(a[x], x);
        ans -= gt_ls(a[x], n - 1) - gt_ls(a[x], x);
        del(a[x], x);
        cout << ans << " ";
    }
    return 0;
}
