#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define pb push_back

using namespace std;
using namespace __gnu_pbds;

template <typename T>
using oset = tree <T, null_type, less <T>, rb_tree_tag, tree_order_statistics_node_update>;


int n;
int a[1000001];
oset <int> st[1000001];

long long ans = 0;

void add(int x, int ps) {
    while(ps < n) {
        st[ps].insert(x);
        ps = (ps|(ps + 1));
    }
}

int gt_mr(int x, int ps) {
    int ans = 0;
    while(ps >= 0) {
        ans += st[ps].size() - st[ps].order_of_key(x + 1);
        ps = (ps&(ps + 1)) - 1;
    }
    return ans;
}

int gt_ls(int x, int ps) {
    int ans = 0;
    while(ps >= 0) {
        ans += st[ps].order_of_key(x);
        ps = (ps&(ps + 1)) - 1;
    }
    return ans;
}
int pos[1000000];
int Q[1000001];
bool F[1000001];

int main() {

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        pos[a[i]] = i;
    }
    vector <long long> A;
    A.pb(0);

    for(int i = 0; i < n - 2; i++) {
        cin >> Q[i];
        F[Q[i]] = 1;
    }
    for (int i = 0; i < n; i++) {
        if(!F[a[i]]) add(a[i], i);
    }
    reverse(Q, Q + n - 2);
    for (int i = 0; i < n - 2; i++) {
//        cout << Q[i] << "\n";
        int x = pos[Q[i]];
        ans += gt_mr(a[x], x);
        ans += gt_ls(a[x], n - 1) - gt_ls(a[x], x);
        add(a[x], x);
        A.pb(ans);
    }
    reverse(A.begin(), A.end());
    for (auto& x : A) cout << x << " ";
    cout << "\n";
    return 0;
}
