#include <bits/stdc++.h>

#pragma GCC target ("avx2")
#pragma GCC optimize ("-O3")
#pragma GCC optimize ("unroll-loops")

#define f first
#define s second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define pb push_back
#define int long long

using namespace std;

typedef long long ll;

const ll inf = 1e18;
const int MAX = 1e5;

int n;

struct fenwick {
    int cnt;
    vector<short> f;

    inline fenwick() {
        f.resize(MAX + 10);
        cnt = 0;
    };

    inline void update(int p, int x) {
        p += 3;
        for(; p < f.size(); p += p & -p) {
            f[p] += x;
        }
        cnt += x;
    };

    inline int get(int p) {
        p += 3;
        int ans = 0;
        for(; p; p -= p & -p) {
            ans += f[p];
        }
        return ans;
    };

    inline int get(int l, int r) {
        if(r < 0) {
            return 0;
        }
        int ans = get(r) - get(l - 1);
        return ans;
    }
};

const int buben = 1300;

inline void solve() {
//    int s = 0;
//    for(int i = 0; i < 3e8; i++) {
//        s += i;
//    }
//    cout << s << endl;
//    return;
    cin >> n;
    vector<int> a(n);
    for(auto &i : a) {
        cin >> i;
        i--;
    }
    int nb = (n + buben - 1) / buben;
    vector<int> num(n);
    vector<int> pos(n);
    for(int i = 0; i < n; i++) {
        pos[a[i]] = i;
    }
    for(int i = 0; i < n; i++) {
        num[i] = i / buben;
    }
    vector<int> lf(nb), rt(nb);
    for(int i = 0; i < nb; i++) {
        lf[i] = i * buben;
        rt[i] = min(i * buben + buben - 1, n - 1);
    }
    vector<fenwick> c(nb);
    ll ans = 0;
    for(int i = 0; i < n; i++) {
        int bl = num[i];
        c[bl].update(a[i], 1);
    }
    fenwick curr;
    for(int i = 0; i < n; i++) {
        ans += curr.cnt - curr.get(a[i]);
        curr.update(a[i], 1);
    }
    int q = n - 2;
    cout << ans << " ";
    while(q--) {
        int x;
        cin >> x;
        x--;
        int p = pos[x];
        int bl = num[p];
        for(int i = 0; i < bl; i++) {
            ans -= c[i].cnt - c[i].get(x);
        }
        for(int i = bl + 1; i < nb; i++) {
            ans -= c[i].get(x);
        }
        for(int i = lf[bl]; i < p; i++) {
            if(!~a[i]) {
                continue;
            }
            ans -= (a[i] > x);
        }
        for(int i = p + 1; i <= rt[bl]; i++) {
            if(!~a[i]) {
                continue;
            }
            ans -= (a[i] < x);
        }
        c[bl].update(x, -1);
        a[p] = -1;
        cout << ans << " ";
    }
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    solve();
}
