
/*
___________________________________________________________
|                                                         |
***********************************************************
***********************************************************
|                                                         |
|                            *                            |
|                         *     *                         |
|             *  *  *  *   *  *  *  *  *  *  *            |
|               *     *             *       *             |
|                *  *                 *   *               |
|                 *        ISRAEL        *                |
|               *  *                   *  *               |
|             *  *  *  *  *  *  *  *  *  *  *             |
|                     *             *                     |
|                       *         *                       |
|                         *     *                         |
|                            *                            |
|                                                         |
***********************************************************
***********************************************************
|_________________________________________________________|
*/
#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef pair<ll, ll> pll;
typedef pair<ll, ll> pii;
#define all(a) a.begin(),a.end()
#define rep(i,a,b) for(ll i=a;i<b;i++)
#define rep1(i,a,b) for(ll i=a;i>b;i--)
#define mod 1000000007
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;

#define set1 tree<int,null_type,less<int>,rb_tree_tag,tree_order_statistics_node_update>

struct mseg {
    int l, r, mid;
    set1 vec;
    mseg* bl, * br;
    mseg(int l,int r,vector<int>er):l(l),r(r),mid((l+r)/2) {
        vector<int>er1, er2;
        rep(i, 0, er.size()) {
            vec.insert(er[i]);
            if (i + l <= mid)
                er1.push_back(er[i]);
            else
                er2.push_back(er[i]);
        }
        if (l < r) {
            bl = new mseg(l, mid, er1);
            br = new mseg(mid + 1, r, er2);
        }
    }
    void update(int x, int i) {
        if (l == r) {
            vec.erase(x);
            return;
        }
        if(i<=mid)
            bl->update(x, i);
        else
            br->update(x, i);
        vec.erase(x);
    }
    int q1(int a, int b,int x) {
        if (a <= l and r <= b) {
            return vec.order_of_key(x);
        }
        if (l > b or r < a) return 0;
        return bl->q1(a, b,x) + br->q1(a, b,x);
    }
    int q2(int a, int b,int x) {
        if (a <= l and r <= b) {
            return (vec.size()-vec.order_of_key(x));
        }
        if (l > b or r < a) return 0;
        return bl->q2(a, b,x) + br->q2(a, b,x);
    }
};
int main() {
    int n;
    cin >> n;
    vector<int>vec(n);
    vector<int>his(n + 1);
    rep(i, 0, n) {
        cin >> vec[i];
        his[vec[i]] = i + 1;
    }
    mseg seg(1, n, vec);
    ll ans = 0;
    rep(i, 1, n+1) {
        ans += seg.q1(i + 1, n, vec[i]);
    }
    cout << ans << endl;
    int q = n - 2;
    while (q--) {
        int x;
        cin >> x;
        int i = his[x];
        seg.update(x, i);
        ans -= seg.q1(i + 1, n, x);
        ans -= seg.q2(1, i - 1, x);
        cout << ans << endl;
    }
}