#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
#define debug(x) cerr << #x << " " << x << "\n"
#define debugs(x) cerr << #x << " " << x << " "

using namespace std;

typedef long long ll;
typedef pair <int, int> pii;

const int NMAX = 100002;

vector <int> aib[NMAX], vals[NMAX];
int poz[NMAX];
int v[NMAX];
int n;

void sim(int val, int poz)
{
    for(int i = val; i <= n; i+=i&(-i))
    {
        vals[i].push_back(poz);
    }
    for(int i = val; i > 0; i-=i&(-i))
    {
        vals[i].push_back(poz);
    }
}

void updateM(int val, int poz, int cat)
{
    for(int i = val; i <= n; i += i&(-i))

    {
        int np = lower_bound(vals[i].begin(), vals[i].end(), poz) - vals[i].begin() + 1;
        for(int j = np; j < aib[i].size(); j += j&(-j))
            aib[i][j] += cat;
    }
}
int queryM(int val, int poz)
{
    int cat = 0;
    for(int i = val; i > 0; i -= i&(-i))
    {
        int np = upper_bound(vals[i].begin(), vals[i].end(), poz) - vals[i].begin();
        for(int j = np; j > 0; j -= j&(-j))
            cat += aib[i][j];
    }
    return cat;
}

int main ()
{
    //ifstream cin(".in");
    //ofstream cout(".out");
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int i;
    cin >> n;
    for(i = 1; i <= n; i++)
    {
        int x;
        cin >> x;
        v[i] = x;
        poz[x] = i;
        sim(x, i);
    }
    for(i = 1; i <= n; i++)
    {
        sort(vals[i].begin(), vals[i].end());
        aib[i].resize(vals[i].size() + 5, 0);
    }
    ll total = 0;
    for(i = 1; i <= n; i++)
    {
        int x = v[i];
        total += queryM(n, i) - queryM(x, i);
        updateM(x, i, 1);
    }
    cout << total << " ";
    for(i = 1; i <= n - 2; i++)
    {
        int x;
        cin >> x;
        updateM(x, poz[x], -1);
        int rez = queryM(n, poz[x]) - queryM(x, poz[x]) + queryM(x, n) - queryM(x, poz[x]);
        total -= rez;
        cout << total << " ";
    }
    return 0;
}
