#include <bits/stdc++.h>
#include <thread>
#pragma GCC optimize("Ofast")
#include <ext/pb_ds/assoc_container.hpp>
#define x first
#define y second
#define pii pair <int, int>
#define ll long long
#define ld long double
#define lsb(x) ((x) & (-(x)))

using namespace std;
using namespace __gnu_pbds;

mt19937 gen(time(0));
uniform_int_distribution <int64_t> rng;

int n;

int v[100005], w[100005];
bool viz[100005];
vector <int> a[100005], aib[100005];
int poz[100005], ans[100005];

void pre_update(int x, int y) {
    for(int i = x; i <= n; i += lsb(i)) {
        a[i].push_back(y);
    }
}

void update(int x, int y, int val) {
    for(int i = x; i <= n; i += lsb(i)) {
        for(int j = lower_bound(a[i].begin(), a[i].end(), y) - a[i].begin(); j < aib[i].size(); j += lsb(j))
            aib[i][j] += val;
    }
}

int query(int x, int y) {
    if(!x || !y)
        return 0;

    int ans = 0;
    for(int i = x; i >= 1; i -= lsb(i)) {
        for(int j = upper_bound(a[i].begin(), a[i].end(), y) - a[i].begin() - 1; j >= 1; j -= lsb(j))
            ans += aib[i][j];
    }

    return ans;
}

ll sum(int a, int b, int c, int d) {
    if(a > c || b > d)
        return 0;

    return query(c, d) - query(c, b - 1) - query(a - 1, d) + query(a - 1, b - 1);
}

void solve() {
    cin >> n;
    for(int i = 1; i <= n; i++)
        cin >> v[i], poz[v[i]] = i;

    for(int i = 1; i <= n; i++)
        pre_update(i, v[i]);

    for(int i = 1; i <= n; i++) {
        a[i].push_back(0);
        sort(a[i].begin(), a[i].end());
        aib[i].resize(a[i].size() + 1);
    }

    for(int i = 1; i <= n - 2; i++)
        cin >> w[i], viz[w[i]] = 1;

    for(int i = 1; i <= n; i++) {
        if(!viz[v[i]]) {
            update(i, v[i], 1);
            ans[n - 1] += sum(1, v[i] + 1, i - 1, n);
        }
    }

    for(int i = n - 2; i >= 1; i--) {
        int x = poz[w[i]];
        update(x, v[x], 1);
        ans[i] = ans[i + 1] + sum(x + 1, 1, n, v[x] - 1) + sum(1, v[x] + 1, x - 1, n);
    }

    for(int i = 1; i <= n - 1; i++)
        cout << ans[i] << " ";
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int T = 1;

    while(T--) {
        solve();
    }
    return 0;
}
