#include <bits/stdc++.h>
#pragma GCC optimize("Ofast", "unroll-loops")
using namespace std;

vector <int> aib[100001], Ys[100001];
int p[100001], where[100001];
int aib1dpoz[100001], aib1dval[100001];
int n;

int lsb(int x)
{
    return x & -x;
}

void baga(int x, int y)
{
    for(; x <= n; x += lsb(x))
        Ys[x].push_back(y);
}

void update(int x, int y, int val)
{
    for(; x <= n; x += lsb(x))
    {
        int y1 = 1 + (lower_bound(Ys[x].begin(), Ys[x].end(), y) - Ys[x].begin());
        for(; y1 <= (int) Ys[x].size(); y1 += lsb(y1))
            aib[x][y1] += val;
    }
}

int query(int x, int y)
{
    int sum = 0;
    for(; x > 0; x -= lsb(x))
    {
        int y1 = 1 + (upper_bound(Ys[x].begin(), Ys[x].end(), y) - Ys[x].begin()) - 1;
        for(; y1 > 0; y1 -= lsb(y1))
            sum += aib[x][y1];
    }
    return sum;
}

void update1dpoz(int poz, int val)
{
    for(; poz <= n; poz += lsb(poz))
        aib1dpoz[poz] += val;
}

void update1dval(int poz, int val)
{
    for(; poz <= n; poz += lsb(poz))
        aib1dval[poz] += val;
}

int query1dpoz(int poz)
{
    int sum = 0;
    for(; poz > 0; poz -= lsb(poz))
        sum += aib1dpoz[poz];
    return sum;
}

int query1dval(int poz)
{
    int sum = 0;
    for(; poz > 0; poz -= lsb(poz))
        sum += aib1dval[poz];
    return sum;
}

int main()
{
#ifdef HOME
    freopen("test.in", "r", stdin);
    freopen("test.out", "w", stdout);
#endif // HOME
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin >> n;
    for(int i = 1; i <= n; i++)
    {
        cin >> p[i];
        where[p[i]] = i;
        baga(p[i], i);
    }
    for(int i = 1; i <= n; i++)
    {
        sort(Ys[i].begin(), Ys[i].end());
        aib[i].resize(1 + Ys[i].size());
    }
    long long ans = 0;
    for(int i = 1; i <= n; i++)
    {
        ans += i - 1 - query(p[i], i);
        update(p[i], i, 1);
        update1dval(p[i], 1);
        update1dpoz(i, 1);
    }
    cout << ans << " ";
    //cout << '\n';
    for(int i = 1; i <= n - 2; i++)
    {
        int x;
        cin >> x;
        int in_spate = query1dpoz(where[x]) - 1, mai_mici_in_spate = query(x, where[x]) - 1, mai_mici_existente = query1dval(x) - 1;
        ans -= (in_spate - mai_mici_in_spate) + (mai_mici_existente - mai_mici_in_spate);
        update(x, where[x], -1);
        update1dval(x, -1);
        update1dpoz(where[x], -1);
        cout << ans << " ";
        //cout << in_spate << " " << mai_mici_existente << " " << mai_mici_in_spate << '\n';
    }
    return 0;
}
