#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

template<typename T> 
void print(vector<T> v) 
{
	cout << " ---> ";
	for (auto &x : v)
	{
		cout << x << " ";
	}
	cout << "\n";
}

int main() 
{
#ifdef ONPC
	freopen ("in.txt", "r", stdin);
#endif 	

#ifndef ONPC
	ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#endif 

	int n;
	cin >> n;
	vector<int> aib1d(n + 1, 0);
	auto add1d = [&] (int i, int x) 
	{	
		i++;
		while (i <= n) 
		{
			aib1d[i] += x;
			i += i & (-i);
		}
	};	
	auto get1d = [&] (int i)
	{
		i++;
		int sol = 0;
		while (i)
		{
			sol += aib1d[i];
			i -= i & (-i);
		}
		return sol;
	};
	vector<int> a(n);
	vector<int> p(n);
	vector<int> cur(n, -1);
	vector<int> del(n - 2, -1);
	vector<bool> used(n, 0);

	for (int i = 0; i < n; i++) 
	{
		cin >> a[i];
		a[i]--;
		p[a[i]] = i;
	}	

	for (int i = 0; i < n - 2; i++)
	{
		cin >> del[i];
		del[i]--;
		used[del[i]] = 1;
	}

	for (int x = 0; x < n; x++) 
	{
		if (used[x] == 0)
		{
			del.push_back(x);
		}
	}

	reverse(del.begin(), del.end());
	vector<ll> sol(n, 0);
	ll current = 0;
	for (int step = 0; step < n; step++) 
	{
		int x = del[step];
		current += step - get1d(x);
		add1d(x, +1);
		for (int i = p[x] + 1; i < n; i++)	
		{
			if (cur[i] != -1)
			{
				current -= (cur[i] > x);
			}
		}
		for (int i = p[x] + 1; i < n; i++)	
		{
			if (cur[i] != -1)
			{
				current += (cur[i] < x);
			}
		}
		cur[p[x]] = x;
		sol[step] = current;
		//cout << x << "\n";
		/**
		 insert x
		**/
	}
	for (int i = n - 1; i >= 1; i--)
	{
		cout << sol[i] << " ";
	}
	cout << "\n";
	//print(del);
	
}
