#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

const int N_MAX = 100000;

int N;
int P[N_MAX + 2];
int pos[N_MAX + 2];

int Q[N_MAX + 2];

map <pair <int, int>, int> Fen;
void update (int x, int y, int val) {
    for (int i = x; i <= N; i += i & -i) {
        for (int j = y; j <= N; j += j & -j) {
            Fen[make_pair(i, j)] += val;
        }
    }
}
int query (int x, int y) {
    int sum = 0;
    for (int i = x; i >= 1; i -= i & -i) {
        for (int j = y; j >= 1; j -= j & -j) {
            sum += Fen[make_pair(i, j)];
        }
    }
    return sum;
}

ll answer[N_MAX + 2];

int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    cin >> N;
    ll total = 0;
    for (int i = 1; i <= N; i++) {
        cin >> P[i];
        pos[P[i]] = i;
        total += query(i, N) - query(i, P[i]);
        update(i, P[i], +1);
    }
    for (int i = 1; i <= N - 2; i++) {
        cin >> Q[i];
    }
    answer[0] = total;
    for (int i = 1; i <= N - 2; i++) {
        int j = pos[Q[i]];
        update(j, P[j], -1);
        total -= query(j, N) - query(j, P[j]);
        total -= query(N, P[j]) - query(j, P[j]);
        answer[i] = total;
    }
    for (int i = 0; i <= N - 2; i++) {
        cout << answer[i] << " ";
    }
    cout << "\n";

    return 0;
}
