#include <vector>
#include <stdio.h>

using namespace std;

int main() {
	int n;
	scanf("%d", &n);
	
	vector<int> a(n);
	for (int i=0; i<n; i++) scanf("%d", &a[i]);
	
	vector<vector<long long>> pairs(n+1);
	vector<bool> exists;
	
	long long disorder = 0;
	
	for (int i=0; i<n-1; i++) {
		for (int j=i+1; j<n; j++) {
			if (a[i] > a[j]) {
				pairs[a[i]].push_back(disorder);
				pairs[a[j]].push_back(disorder);
				exists.push_back(true);
				disorder++;
			}
		}
	}
	
	printf("%lld ", disorder);
	
	for (int i=0; i<n-2; i++) {
		int ai;
		scanf("%d", &ai);
		
		for (int j=0; j<pairs[ai].size(); j++) {
			long long par = pairs[ai][j];
			if (!exists[par]) continue;
			
			exists[par] = false;
			disorder--;
		}
		
		printf("%lld ", disorder);
	}
}
