#pragma GCC optimize("Ofast")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

#define ll long long
#define pb push_back
#define point pair<int, int>
#define X first
#define Y second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define show(x) cerr << (#x) << " = " << x << '\n'
#define print(x) if (1) {for (auto it : x) cerr << it << ' '; cerr << '\n';}
#define fast_io ios_base::sync_with_stdio(0), cin.tie(0)

const int N = 2e5 + 64;
const int INF = 2e9 + 64;
const int MOD = 1e9 + 7;
const ll MAX = 2e18  + 64;
const int LOG = 30;

template<class T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

int n, p[N], q[N], e[N];
ll ans = 0;
ordered_set<int> t[N];
bitset<N> used;

int smaller(int l, int r, int x) {
	int res = 0;
	for (l += n, r += n + 1; l < r; l >>= 1, r >>= 1) {
		if (l & 1)
			res += t[l].order_of_key(x), ++l;
		if (r & 1)
			--r, res += t[r].order_of_key(x);
	}
	return res;
}

int bigger(int l, int r, int x) {
	int res = 0;
	for (l += n, r += n + 1; l < r; l >>= 1, r >>= 1) {
		if (l & 1)
			res += t[l].size() - t[l].order_of_key(x), ++l;
		if (r & 1)
			--r, res += t[r].size() - t[r].order_of_key(x);
	}
	return res;
}

void insert(int pos) {
	ans += bigger(0, pos - 1, p[pos]) + smaller(pos + 1, n - 1, p[pos]);

	int x = pos;
	for (t[pos += n].insert(p[x]); pos > 0; pos >>= 1)
		t[pos].insert(p[x]);
}

signed main() {
	fast_io;

	cin >> n;

	for (int i = 0; i < n; ++i)
		cin >> p[i], --p[i], q[p[i]] = i;

	for (int i = n - 3; i >= 0; --i)
		cin >> e[i], --e[i], used[e[i]] = true;

	for (int i = 0; i < n; ++i)
		if (!used[p[i]])
			insert(i);

	vector<int> res = {ans};

	for (int i = 0; i + 2 < n; ++i)
		insert(q[e[i]]), res.pb(ans);

	reverse(all(res));
	for (auto it : res)
		cout << it << ' ';
}
