#include <bits/stdc++.h>

const int N = 1e5;

using namespace std;

typedef long long ll;
typedef pair<int, int> pi;

class seg{
    int n;
    vector<ll> s;
    ll comb(ll a, ll b){return a + b;}
    public:
    seg(int _n): n(_n), s(2 * _n, 0){}
    void upd(int v, int d){
        s[v += n] = d; for(v >>= 1; v; v >>= 1) s[v] = comb(s[v << 1], s[v << 1 | 1]);
    }
    int get(int l, int r){
        int rs = 0;
        for(l += n, r += n + 1; l < r; l >>= 1, r >>= 1){
            if(l & 1) rs = comb(rs, s[l++]);
            if(r & 1) rs = comb(rs, s[--r]);
        }
        return rs;
    }
};

int main(){
    int n, a[N];
    cin >> n;
    for(int i = 0; i < n; ++i) cin >> a[i], --a[i];
    ll rs = 0;
    seg s(n);
    for(int i = 0; i < n; ++i){
        rs += s.get(a[i], n);
        s.upd(a[i], 1);
    }
    cout << rs << ' ';
    int sq = 894;
    ll r[N], l[N], rev[N];
    for(int i = 0; i < n; ++i)
        rev[a[i]] = i;
    bool usd[N]{};
    vector<int> ex;
    seg sr(n), sl(n);
    for(int i = 0, t = 0; i < n - 2; t = i){
        ex.clear();
        for(int i = 0; i < n; ++i)
            sr.upd(i, 0), sl.upd(i, 0);
        for(int j = 0; j < n; ++j) if(!usd[j]){
            l[j] = sl.get(a[j], n - 1);
            sl.upd(a[j], 1);
        }
        for(int j = n - 1; j >= 0; --j) if(!usd[j]){
            r[j] = sr.get(0, a[j]);
            sr.upd(a[j], 1);
        }
        for(int c; i < n - 2 && i - t < sq; ++i){
            cin >> c; --c;
            usd[c] = 1;
            ll e = 0;
            for(int k: ex) if((rev[k] > rev[c]) != (k > c))
                ++e;
            rs += e - l[rev[c]] - r[rev[c]];
            cout << rs << ' ';
            ex.push_back(c);
        }
    }
}
