#include <iostream>
#include <vector>

using namespace std;

int main() {
    int n; cin >> n;
    vector<int> v(n);
    for (int i = 0; i < n; ++i) cin >> v[i], --v[i];
    vector<int> t(n, n-1);
    for (int i = 1; i <= n-2; ++i) {
        int x; cin >> x; x--;
        t[x] = i;
    }
    vector<int> disorder(n);
    for (int i = 0; i < n; ++i) {
        for (int j = i+1; j < n; ++j) {
            if (v[i] < v[j]) continue;
            int upTo = min(t[v[i]], t[v[j]])-1;
            ++disorder[upTo];
        }
    }
    for (int i = n-2; i >= 0; --i) disorder[i] += disorder[i+1];
    for (int i = 0; i < n-1; ++i) cout << disorder[i] << ' ';
    cout << endl;
    return 0;
}
