#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define all(c) c.begin(),c.end()
#define sz(c) (int)c.size()
#define f first
#define s second

// This is kinda like dp maybe?
// need to cater for the dynamic updates
// can think of an easy O(n^2) solution that won't get full marks
// It won't as mxN = 1e5
// However a good O(n^2) solution would get 85% I think
// need to update the ones behind and ahead
// use a segment tree?
// can efficiently get the number larger ahead and lower behind
// unsure how to cope with updates though
// I will try to implement an O(n^2) solution for now I think
// this will get me some partial points
// if we have sets for before and after we can find the number?
// This current one might be O(n^3)

const ll mxN = 1e5;
ll score(vector<ll>& a) {
	ll out = 0;
	vector<ll> bigger(mxN+1,0);
	for (ll i = 0; i < sz(a); i++) {
		out += bigger[a[i]];
		for (ll j = a[i]-1; j >= 1; j--)
			bigger[j]++;
	}
	return out;
}

void solve() {
	ll n;
	cin >> n;
	vector<ll> a(n), b(n-2);
	for (ll& i : a)
		cin >> i;
	for (ll& i : b)
		cin >> i;

	cout << score(a) << " ";
	for (ll i = 0; i < sz(b); i++) {
		vector<ll> newa;
		for (ll j = 0; j < sz(a); j++)
			if (a[j] != b[i])
				newa.push_back(a[j]);

		a = newa;

		cout << score(a) << (i == sz(b)-1 ? "" : " ");
	}
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);

	solve();
}
