#include<bits/stdc++.h>
#define MAXN 100007
using namespace std;

int n;
int p[MAXN],a[MAXN],rem[MAXN];
long long curr,ans[MAXN];

int fenwick[MAXN],li[MAXN],tim;
int temp[MAXN],pt,id,cnt;

void check(int x){
    if(li[x]!=tim)fenwick[x]=0;
    li[x]=tim;
}

void update(int x){
    while(x<=n){
        check(x);
        fenwick[x]++;
        x+=(x & (-x));
    }
}

int getsum(int x){
    int res=0;
    while(x>=1){
        check(x);
        res+=fenwick[x];
        x-=(x & (-x));
    }
    return res;
}

void solve(int l,int r){
    if(l==r)return;

    int mid=(l+r)/2;
    solve(l,mid);
    solve(mid+1,r);

    tim++; pt=mid+1; id=l; cnt=0;
    for(int i=l;i<=mid;i++){
        while(pt<=r and p[pt]<p[i]){
            temp[id]=p[pt]; id++;
            update(rem[p[pt]]); pt++;
            cnt++;
        }
        curr+=cnt;
        ans[p[i]]+=getsum(n)-getsum(rem[p[i]]);
        temp[id]=p[i]; id++;
    }
    while(pt<=r){
        temp[id]=p[pt]; id++;
        update(rem[p[pt]]); pt++;
    }

    tim++; pt=r;
    for(int i=mid;i>=l;i--){
        while(pt>=mid+1 and p[pt]>p[i]){
            ans[p[pt]]+=getsum(n)-getsum(rem[p[pt]]); pt--;
        }
        update(rem[p[i]]);
    }
    while(pt>=mid+1){
        ans[p[pt]]+=getsum(n)-getsum(rem[p[pt]]); pt--;
    }

    for(int i=l;i<=r;i++){
        p[i]=temp[i];
    }
}

int main(){
    
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n;
    for(int i=1;i<=n;i++){
        cin>>p[i];
    }
    for(int i=1;i<=n;i++)rem[i]=n;

    for(int i=1;i<=n-2;i++){
        cin>>a[i];
        rem[a[i]]=i;
    }

    solve(1,n);

    cout<<curr<<" ";
    for(int i=1;i<=n-2;i++){
        curr-=ans[a[i]];
        cout<<curr<<" ";
    }
    cout<<"\n";

    return 0;
}

