#include<iostream>
#include<string.h>
#define MAXN 100007
using namespace std;

int fenwick[MAXN+1],used[MAXN+1],time1,n;
void update(int pos,int num)
{
    for (;;)
    {
        if (pos>n) break;
        if (used[pos]<time1) fenwick[pos]=0;
        used[pos]=time1;
        fenwick[pos]+=num;
        pos+=pos&(-pos);
    }
}
int prefix_sum(int pos)
{
    int num=0;
    for (;;)
    {
        if (pos==0) break;
        if (used[pos]<time1) fenwick[pos]=0;
        used[pos]=time1;
        num+=fenwick[pos];
        pos-=pos&(-pos);
    }
    return num;
}
int a[MAXN],q[MAXN],indq[MAXN+1],t[MAXN],rem[MAXN+1];
long long int total=0;
void merge1(int l, int mid, int r)
{
    int indl=l,indr=mid+1,ind=l,i;
    time1++;
    for (;;)
    {
        if ((indl>mid)&&(indr>r)) break;
        if ((indl>mid)||((indr<=r)&&(a[indr]>a[indl])))
        {
           rem[a[indr]]+=prefix_sum(indq[a[indr]]);
           total+=(indl-l);
           t[ind++]=a[indr];
           indr++;
        }
        else
        {
            update(indq[a[indl]],1);
            t[ind++]=a[indl];
            indl++;
        }
    }
    indl=mid;indr=r;
    time1++;
    for (;;)
    {
        if ( (indl<l)&&(indr<mid+1) ) break;
        if ((indl<l)|| ( (indr>mid)&&(a[indr]<a[indl]) ))
        {
            update(indq[a[indr]],1);
            indr--;
        }
        else
        {
            rem[a[indl]]+=prefix_sum(indq[a[indl]]);
            indl--;
        }
    }
    for (i=l;i<=r;i++)
    {
        a[i]=t[i];
    }
}
void merge_sort(int l, int r)
{
    if (l==r) return;
    int mid=(l+r)/2;
    merge_sort(l,mid);
    merge_sort(mid+1,r);
    merge1(l,mid,r);
}
int main()
{
    int i;
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin>>n;
    for (int i=0;i<n;i++)
    {
        cin>>a[i];
        indq[i+1]=1;
    }
    for (int i=0;i<n-2;i++)
    {
        cin>>q[i];
        indq[q[i]]=n-1-i;
    }
    merge_sort(0,n-1);
    cout<<total<<" ";
    for (int i=0;i<n-2;i++)
    {
        total-=rem[q[i]];
        cout<<total<<" ";
    }

}
