#include <iostream>
using namespace std;
const int MAXN=1e5+10;
int a[MAXN], b[MAXN], fen[MAXN], pl[MAXN], rem[MAXN], ord[MAXN];
int n, inv;
void update(int x, int ch) {
    while (x<=n) {
        fen[x]+=ch;
        x+=(x&(-x));
    }
}
int query(int x) {
    int ans=0;
    while (x>0) {
        ans+=fen[x];
        x-=(x&(-x));
    }
    return ans;
}
int interval(int l, int r) {
    return query(r)-query(l-1);
}
void merge_sort(int l, int r) {
    if (l==r) return;
    int mid=(l+r)/2;
    merge_sort(l,mid);
    merge_sort(mid+1,r);
    int indr=mid+1, cnt=l;
    for (int i=l;i<=mid;i++) {
        while (indr<=r && a[indr]<a[i]) {
            update(rem[a[indr]],1);
            b[cnt]=a[indr];
            cnt++;
            indr++;
        }
        inv+=indr-mid-1;
        b[cnt]=a[i];
        pl[a[i]]+=interval(rem[a[i]],n);
        cnt++;
    }

    for (int i=mid+1;i<indr;i++) update(rem[a[i]],-1);
    while (indr<=r) {
        b[cnt]=a[indr];
        indr++;
        cnt++;
    }
    int indl=mid;
    for (int i=mid+1;i<=r;i++) {
        while (indl>=l && a[indl]>a[i]) {
            update(rem[a[indl]],1);
            indl--;
        }
        pl[a[i]]+=interval(rem[a[i]],n);
    }
    for (int i=mid;i>indl;i--) update(rem[a[i]],-1);
    for (int i=l;i<=r;i++) a[i]=b[i];
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    for (int i=0;i<n;i++) {
        cin >> a[i];
        rem[a[i]]=-1;
    }
    for (int i=0;i<n-2;i++) {
        cin >> ord[i];
        rem[ord[i]]=i+1;
    }
    for (int i=0;i<n;i++) {
        if (rem[a[i]]==-1) rem[a[i]]=n;
    }
    inv=0;
    merge_sort(0,n-1);
    for (int i=0;i<n-1;i++) {
        cout << inv << ' ';
        if (i<n-1) inv-=pl[ord[i]];
    }
    cout << endl;
    return 0;
}
