#include <bits/stdc++.h>

#define ll long long
#define pii pair<int, int>

using namespace std;

const int MAX = 5001;

vector<int> tree(MAX, 0);

void update(int pos, int val){
    while(pos < MAX){
        tree[pos] += val;
        pos += (pos & -pos);
    }
}

int ask(int pos){
    int ans = 0;
    while(pos > 0){
        ans += tree[pos];
        pos -= (pos & -pos);
    }
    return ans;
}


vector<int> arr;

int solve(){
    fill(tree.begin(), tree.end(), 0);
    int ans = 0;
    for(int i = 0; i < arr.size(); i++){
        ans += ask(arr[i]);
        update(arr[i], 1);
    }
    return ans;
}


int main()
{
    int n; cin >> n;
    arr.resize(n);
    for(int i = 0; i < n; i++){
        cin >> arr[i];
    }
    reverse(arr.begin(), arr.end());
    cout << solve();
    for(int i = 2; i < n; i++){
        int a; cin >> a;
        arr.erase(find(arr.begin(), arr.end(), a));
        cout << ' ' << solve();
    }
}