﻿#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;

#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
using oset = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

const int R = (1 << 17);
vector<oset> t(R * 2);

void insert(int i, int x) {
    int v = R + i;
    while (v > 0) {
        t[v].insert(x);
        v >>= 1;
    }
}

void erase(int i, int x) {
    int v = R + i;
    while (v > 0) {
        t[v].erase(x);
        v >>= 1;
    }
}

int smaller(int x, int sl, int sr, int v = 1, int l = 0, int r = R) {
    if (sl >= r || l >= sr)
        return 0;
    if (sl <= l && r <= sr)
        return (int)t[v].order_of_key(x);
    int m = (l + r) / 2;
    return smaller(x, sl, sr, v * 2, l, m) + smaller(x, sl, sr, v * 2 + 1, m, r);
}

int bigger(int x, int bl, int br, int v = 1, int l = 0, int r = R) {
    if (bl >= r || l >= br)
        return 0;
    if (bl <= l && r <= br)
        return (int)t[v].size() - (int)t[v].order_of_key(x);
    int m = (l + r) / 2;
    return bigger(x, bl, br, v * 2, l, m) + bigger(x, bl, br, v * 2 + 1, m, r);
}

int main() {
    fast;
    int n;
    cin >> n;
    vector<int> a(n), p(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        --a[i];
        p[a[i]] = i;
        insert(i, a[i]);
    }
    long long curr = 0;
    for (int i = 0; i < n; ++i)
        curr += smaller(a[i], i + 1, n);
    cout << curr << ' ';
    for (int i = 2; i < n; ++i) {
        int x;
        cin >> x;
        --x;
        curr -= bigger(x, 0, p[x]) + smaller(x, p[x] + 1, n);
        erase(p[x], x);
        cout << curr << ' ';
    }
}
