#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
using namespace __gnu_pbds;
using oset = tree<int,null_type,less<int>,rb_tree_tag,tree_order_statistics_node_update>;

const int N = 1.5e4 + 10;

oset t[4 * N];
inline void upd(int v, int vl, int vr, int pos, int x) {
	t[v].insert(x);
	if (vl == vr) return;
	int m = vl + vr >> 1;
	if (pos <= m) upd(2 * v + 1, vl, m, pos, x);
	else upd(2 * v + 2, m + 1, vr, pos, x);
}
inline void dupd(int v, int vl, int vr, int pos, int x) {
	t[v].erase(x);
	if (vl == vr) return;
	int m = vl + vr >> 1;
	if (pos <= m) dupd(2 * v + 1, vl, m, pos, x);
	else dupd(2 * v + 2, m + 1, vr, pos, x);
}
inline int get(int v, int vl, int vr, int l, int r, int x, bool f) {
	if (l > r) return 0;
	else if (vl == l && vr == r) {
		int re = t[v].order_of_key(x);
		return f ? t[v].size() - re : re;
	}
	int m = vl + vr >> 1;
	return get(2 * v + 1, vl, m, l, min(r, m), x, f) + get(2 * v + 2, m + 1, vr, max(l, m + 1), r, x, f);
}

signed main() {
	ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

	int n;
	cin >> n;
	vector<int> a(n);
	for (auto &i : a) cin >> i;

	vector<int> ps(n + 1);
	for (int i = 0; i < n; ++i) ps[a[i]] = i;

	int ans = 0;
	for (int i = n - 1; ~i; --i) {
		ans += get(0, 0, n - 1, 0, n - 1, a[i], 0);
		upd(0, 0, n - 1, i, a[i]);
	}
	cout << ans << " ";

	for (int i = 0; i < n - 2; ++i) {
		int x;
		cin >> x;
		int p = ps[x];
		ans -= get(0, 0, n - 1, 0, p - 1, x, 1);
		ans -= get(0, 0, n - 1, p + 1, n - 1, x, 0);
		dupd(0, 0, n - 1, p, x);
		cout << ans << " ";
	}
}
