#include <bits/stdc++.h>

#pragma GCC optimize("O3")

using namespace std;

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
template <typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#define fbo find_by_order
#define ook order_of_key

const int N = 1e5 + 5;

int n;
int a[N];

int pos[N];
oset<int> t[N];

void add(int pos, int x) {
    while (pos <= n) {
        t[pos].insert(x);
        pos = pos | (pos + 1);
    }
}

void del(int pos, int x) {
    while (pos <= n) {
        t[pos].erase(x);
        pos = pos | (pos + 1);
    }
}

int getGreater(int pos, int x) {
    int ans = 0;
    while (pos >= 0) {
        ans += (int)t[pos].size() - t[pos].ook(x);
        pos = (pos & (pos + 1)) - 1;
    }
    return ans;
}

int getLess(int pos, int x) {
    int ans = 0;
    while (pos >= 0) {
        ans += t[pos].ook(x);
        pos = (pos & (pos + 1)) - 1;
    }
    return ans;
}

int main() {
    cin >> n;
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        pos[a[i]] = i;
    }

    oset<int> s;
    long long ans = 0;
    for (int i = 1; i <= n; i++) {
        ans += (int)s.size() - s.ook(a[i]);
        s.insert(a[i]);
    }

    cout << ans << " ";

    for (int i = 1; i <= n; i++) {
        add(i, a[i]);
    }

    for (int i = 1; i < n; i++) {
        int x;
        cin >> x;
        ans -= getGreater(pos[x] - 1, x);
        ans -= getLess(n, x) - getLess(pos[x], x);

        del(pos[x], x);

        cout << ans;
        if (i + 1 < n) cout << " ";
        else cout << "\n";
    }

    return 0;
}
