#include <bits/stdc++.h>

#pragma GCC Optimize ("Ofast")
#pragma GCC Optimize ("03")
#pragma GCC Optimize ("02")

using namespace std;
#define forn(i,n) for(int i=0;i<n;++i)
#define pb(x) push_back(x)
#define f first
#define s second
#define pi pair<int,int>
#define int int16_t
#define vii(a,n) vector<int>a(n);forn(i,n)cin>>a[i];

struct BIT {

    vector<int> t;
    int n;
    BIT(int _n) {
        n=_n;
        t.assign(n,0);
    }
    BIT(vector<int>a) {
        n=a.size();
        t.assign(n,0);
        forn(i,n) add(i,a[i]);
    }
    BIT() {
        n=1;
        t.assign(1,0);
    }
    void init(int _n) {
        n=_n;
        t.assign(n,0);
    }
    int sum(int r) {
        int res=0;
        for (;r>=0;r=(r&(r+1))-1) {
            res+=t[r];
        }
        return res;
    }
    int sum(int l, int r) {
        if (l>r) return 0;
        return sum(r)-sum(l-1);
    }
    void add(int i, int x) {
        for(;i<n;i=i|(i+1)) t[i]+=x;
    }

};

struct aint {

    struct node {
        int* a;
        int sz=0;
        map<int,int> pos;
        BIT ft;
    };
    vector<node> t;
    int n;
    int sz=1;

    void initnode(node&a,int x) {
        a.a = new int[1];
        a.a[0]=x;
        a.pos[x]=0;
        a.sz=1;
    }

    void merge(node&a,node&x,node&y) {
        int s=x.sz+y.sz;
        a.sz=s;
        a.a = new int[s];
        a.ft.init(s);
        int i=0, j=0, p=0;
        while ((i<x.sz) && (j<y.sz)) {
            if (x.a[i]>y.a[j]) {
                a.a[p++]=x.a[i++];
            } else {
                a.a[p++]=y.a[j++];
            }
        }
        while (i<x.sz) {
            a.a[p++]=x.a[i++];
        }
        while (j<y.sz) {
            a.a[p++]=y.a[j++];
        }
        forn(k,s) a.pos[a.a[k]]=k;
    }

    void update(int i, int l, int r) {
        if (r-l==1) return;
        int mid=(l+r)>>1;
        update(2*i+1,l,mid);
        update(2*i+2,mid,r);
        merge(t[i],t[2*i+1],t[2*i+2]);
    }

    aint(vector<int>&a) {
        n=a.size();
        while(sz<n)sz<<=1;
        t.resize(2*sz-1);
        forn(i,n) initnode(t[sz+i-1],a[i]);
        update(0,0,sz);
    }

    int query(int i, int l, int r, int lx, int rx, int x) {
        //cout<<i<<' '<<l<<' '<<r<<' '<<lx<<' '<<rx<<' '<<x<<'\n';
        if (l>=rx) return 0;
        if (r<=lx) return 0;
        if (l>=lx && r<=rx) {

            int L=-1,R=t[i].sz-1;
            while (L<R) {
                int mid=(L+R+1)>>1;
                if (t[i].a[mid]<x) R=mid-1;
                else L=mid;
            }
            return R+1 - t[i].ft.sum(0,R);

        }
        int mid=(l+r)>>1;
        return query(2*i+1,l,mid,lx,rx,x) + query(2*i+2,mid,r,lx,rx,x);
    }

    int query(int l, int r, int x) {
        //cout<<"! "<<l<<' '<<r<<' '<<x<<'\n';
        //exit(0);
        if (l>=r) return 0;
        return query(0,0,sz,l,r,x);
    }

    void set(int i, int l, int r, int x, int j) {
        if (l>j || r<=j) return;
        int p=t[i].pos[x];
        t[i].ft.add(p,1);
        int mid=(l+r)>>1;
        if (r-l==1) return;
        set(2*i+1,l,mid,x,j);
        set(2*i+2,mid,r,x,j);
    }
    void set(int x,int j) {
        set(0,0,sz,x,j);
    }

};

struct aint2 {

    struct node {
        int* a;
        int sz=0;
        map<int,int> pos;
        BIT ft;
    };
    vector<node> t;
    int n;
    int sz=1;

    void initnode(node&a,int x) {
        a.a = new int[1];
        a.a[0]=x;
        a.pos[x]=0;
        a.sz=1;
    }

    void merge(node&a,node&x,node&y) {
        int s=x.sz+y.sz;
        a.sz=s;
        a.a = new int[s];
        a.ft.init(s);
        int i=0, j=0, p=0;
        while ((i<x.sz) && (j<y.sz)) {
            if (x.a[i]<y.a[j]) {
                a.a[p++]=x.a[i++];
            } else {
                a.a[p++]=y.a[j++];
            }
        }
        while (i<x.sz) {
            a.a[p++]=x.a[i++];
        }
        while (j<y.sz) {
            a.a[p++]=y.a[j++];
        }
        forn(k,s) a.pos[a.a[k]]=k;
    }

    void update(int i, int l, int r) {
        if (r-l==1) return;
        int mid=(l+r)>>1;
        update(2*i+1,l,mid);
        update(2*i+2,mid,r);
        merge(t[i],t[2*i+1],t[2*i+2]);
    }

    aint2(vector<int>&a) {
        n=a.size();
        while(sz<n)sz<<=1;
        t.resize(2*sz-1);
        forn(i,n) initnode(t[sz+i-1],a[i]);
        update(0,0,sz);
    }

    int query(int i, int l, int r, int lx, int rx, int x) {
        if (l>=rx) return 0;
        if (r<=lx) return 0;
        if (l>=lx && r<=rx) {

            int L=-1,R=t[i].sz-1;
            while (L<R) {
                int mid=(L+R+1)>>1;
                if (t[i].a[mid]>x) R=mid-1;
                else L=mid;
            }
            return R+1 - t[i].ft.sum(0,R);

        }
        int mid=(l+r)>>1;
        return query(2*i+1,l,mid,lx,rx,x) + query(2*i+2,mid,r,lx,rx,x);
    }

    int query(int l, int r, int x) {
        if (l>=r) return 0;
        return query(0,0,sz,l,r,x);
    }

    void set(int i, int l, int r, int x, int j) {
        if (l>j || r<=j) return;
        int p=t[i].pos[x];
        t[i].ft.add(p,1);
        int mid=(l+r)>>1;
        if (r-l==1) return;
        set(2*i+1,l,mid,x,j);
        set(2*i+2,mid,r,x,j);
    }
    void set(int x,int j) {
        set(0,0,sz,x,j);
    }

};

void solve() {

    int n; cin>>n;
    vii(a,n);
    BIT ft(n+1);
    int ans=0;
    forn(i,n) {
        ans+=ft.sum(a[i],n);
        ft.add(a[i],1);
    }
    cout<<ans<<' ';
    aint st(a);
    aint2 st2(a);

    vector<int> pos(n+1,0);
    forn(i,n) pos[a[i]]=i;
    forn(i,n-2) {
        int x; cin>>x;
        int y=st.query(0,pos[x],x);
        int z=st2.query(pos[x]+1,n,x);
        st.set(x,pos[x]);
        st2.set(x,pos[x]);
        ans-=y+z;
        cout<<ans<<' ';
    }

    return;
    cout<<st.t[0].sz<<'\n';
    forn(i,st.t[0].sz) cout<<st.t[0].a[i]<<' ';

}

int32_t main() {

    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int t=1;
    //cin>>t;
    while (t--) solve();
    return 0;

}
