#include <bits/stdc++.h>
//#include "guess.h"
using namespace std; 

typedef long long ll; 

#define f(i,a,b) for(int i = a; i < b; i++)
#define fa(i,a,b) for(int i = a; i >= b; i--)

const int N = 1e5 + 5; 

int n, a[N], p[N], b[N]; 
bool on[N]; 
vector <int> st[4*N]; 

void merge(vector <int> &v, vector <int> a, vector <int> b){
    int la = a.size(), lb = b.size(); 
    v.resize(la+lb); 

    int id = 0, curr = 0; 
    f(i,0,la){
        while(id < lb and b[id] < a[i]) v[curr++] = b[id++]; 
        v[curr++] = a[i]; 
    }
    while(id < lb) v[curr++] = b[id++]; 
}

void upd(int id, int l, int r, int pos, int val){
    if(l == r){
        st[id].clear(); 
        st[id].push_back(val); 
        return; 
    }
    int m = (l+r)>>1; 
    if(pos <= m) upd(id<<1, l, m, pos, val); 
    else upd(id<<1|1, m+1, r, pos, val); 
    merge(st[id], st[id<<1], st[id<<1|1]); 
}

int get(vector <int> v, int val){
    int l = 0, r = v.size() - 1; 
    if(r == -1 or v[0] >= val) return 0; 
    while(l < r){
        int m = (l+r+1)>>1; 
        if(v[m] >= val) r = m-1; 
        else l = m; 
    }
    return l+1; 
}

int query(int id, int l, int r, int x, int y, int val, int ty){
    if(r < x or y < l) return 0; 
    if(x <= l and r <= y){
        int ra = get(st[id], val); 
        if(ty == 1) return ra; 
        return st[id].size() - ra; 
    }
    int m = (l+r)>>1; 
    return query(id<<1, l, m, x, y, val, ty) + query(id<<1|1, m+1, r, x, y, val, ty); 
}

int main(){
    cin >> n; 

    f(i,0,n){
        cin >> a[i]; 
        p[a[i]] = i; 
    }

    f(i,0,n-2) {
        cin >> b[i]; 
        on[p[b[i]]] = 1; 
    }
    int p1 = -1, p2 = -1; 
    f(i,0,n){
        if(!on[i]){
            if(p1 == -1) p1 = i; 
            else p2 = i; 
        }
    }

    upd(1, 0, n-1, p1, a[p1]); 
    upd(1, 0, n-1, p2, a[p2]); 

    vector <int> ans; 

    ll curr = 0; 
    if(a[p1] > a[p2]) curr = 1; 

    // 1, menores / 2, mayores

    fa(i,n-3,0){
        ans.push_back(curr); 
        int pos = p[b[i]]; 

        ll L = query(1, 0, n-1, 0, pos, b[i], 2), R = query(1, 0, n-1, pos, n-1, b[i], 1); 
        curr += L + R; 

        upd(1, 0, n-1, pos, b[i]); 
    }
    ans.push_back(curr); 

    reverse(ans.begin(), ans.end()); 

    for(int x: ans) cout << x << " "; 
    cout << "\n"; 

    return 0; 
}