#include <bits/stdc++.h>
//#include "guess.h"
using namespace std; 

typedef long long ll; 

#define f(i,a,b) for(int i = a; i < b; i++)
#define fa(i,a,b) for(int i = a; i >= b; i--)

const int N = 1e5 + 5; 

int n, a[N], p[N], b[N], L[400], R[400], block[N], BL; 
bool on[N]; 
vector <int> v[400]; 

void insert(vector <int> &v, int val){
    int l = v.size(); 
    vector <int> ans(l+1); 
  
    int id = 0, curr = 0;
    while(id < l and v[id] < val) ans[curr++] = v[id++]; 
    ans[curr++] = val; 
    while(id < l) ans[curr++] = v[id++]; 
    v = ans;  
}

int get(vector <int> v, int val){
    int l = 0, r = v.size() - 1; 
    if(r == -1 or v[0] >= val) return 0; 
    while(l < r){
        int m = (l+r+1)>>1; 
        if(v[m] >= val) r = m-1; 
        else l = m; 
    }
    return l+1; 
}

void add(int pos, int val){
    int bl = block[pos]; 
    
    insert(v[bl], val); 
    on[pos] = 1; 
}

int C(int x, int val){ // mayores
    int bl = block[x]; 
    int ans = 0;
    f(i,1,bl) ans += v[i].size() - get(v[i], val);  
    f(i,bl+1,BL+1) ans += get(v[i], val); 
    f(i,L[bl], x) if(on[i] and a[i] > val) ans++; 
    f(i,x,R[bl]+1) if(on[i] and a[i] < val) ans++; 
    return ans; 
}   

int main(){
    cin >> n; 

    f(i,0,n){
        cin >> a[i]; 
        p[a[i]] = i; 
    }

    f(i,0,n-2) {
        cin >> b[i]; 
        on[p[b[i]]] = 1; 
    }
    int p1 = -1, p2 = -1; 
    f(i,0,n){
        if(!on[i]){
            if(p1 == -1) p1 = i; 
            else p2 = i; 
        }
    }

    f(i,0,n) on[i] = 0; 

    ll curr = 0; 
    if(a[p1] > a[p2]) curr = 1; 

    int sz = sqrt(n), id = 0; 
    while(1){
        int l = id, r = id + sz - 1; 
        if(r >= n) r = n-1; 

        BL++; 
        f(i,l,r+1){
            block[i] = BL;
        }
        L[BL] = l, R[BL] = r; 
        if(r == n-1) break; 
        id = r+1; 
    }
    add(p1, a[p1]); 
    add(p2, a[p1]); 

    
    vector <ll> ans; 

    fa(i,n-3,0){
        ans.push_back(curr); 
        int pos = p[b[i]]; 

        ll L = C(pos, b[i]); 
        curr += L; 
        on[pos] = 1; 
        add(pos, b[i]); 
    }
    ans.push_back(curr); 
    reverse(ans.begin(), ans.end()); 

    for(int x: ans) cout << x << " "; 
    cout << "\n"; 

    return 0; 
}