#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
#define debug(x) cerr << #x << " " << x << "\n"
#define debugs(x) cerr << #x << " " << x << " "

using namespace std;

typedef long long ll;
typedef pair <int, int> pii;

const int NMAX = 100002;

vector <int> aib[NMAX], vals[NMAX], aib2[NMAX];
int poz[NMAX];
int v[NMAX];
int n;

void sim(int val, int poz){
    for(int i = val; i <= n; i+=i&(-i)){
        vals[i].push_back(poz);
    }
    for(int i = val; i > 0; i-=i&(-i)){
        vals[i].push_back(poz);
    }
}

void updatem(int val, int poz, int cat){
    for(int i = val; i <= n; i += i&(-i))
    {
        int np = lower_bound(vals[i].begin(), vals[i].end(), poz) - vals[i].begin() + 1;
        for(int j = np; j > 0; j -= j&(-j))
            aib[i][j] += cat;
    }
}


void updateM(int val, int poz, int cat){
    for(int i = val; i > 0; i -= i&(-i))
    {
        int np = lower_bound(vals[i].begin(), vals[i].end(), poz) - vals[i].begin() + 1;
        for(int j = np; j < aib2[i].size(); j += j&(-j))
            aib2[i][j] += cat;
    }
}

int querym(int val, int poz){
    int cat = 0;
    for(int i = val; i > 0; i -= i&(-i))
    {
        int np = lower_bound(vals[i].begin(), vals[i].end(), poz) - vals[i].begin() + 1;
        for(int j = np; j < aib[i].size(); j += j&(-j))
            cat += aib[i][j];
    }
    return cat;
}
int queryM(int val, int poz){
    int cat = 0;
    for(int i = val; i <= n; i += i&(-i))
    {
        int np = lower_bound(vals[i].begin(), vals[i].end(), poz) - vals[i].begin() + 1;
        for(int j = np; j > 0; j -= j&(-j))
            cat += aib2[i][j];
    }
    return cat;
}

int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int i;
    cin >> n;
debug(n / 0);
    for(i = 1; i <= n; i++){
        int x;
        cin >> x;
        v[i] = x;
        poz[x] = i;
        sim(x, i);
    }
    for(i = 1; i <= n; i++){
        sort(vals[i].begin(), vals[i].end());
        aib[i].resize(vals[i].size() + 5, 0);
        aib2[i].resize(vals[i].size() + 5, 0);
    }
    ll total = 0;
    for(i = 1; i <= n; i++){
        int x = v[i];
        total += queryM(x, i);
        updateM(x, i, 1);
    }
    cout << total << " ";
    for(i = 1; i <= n - 2; i++){
        int x;
        cin >> x;
        updatem(x, poz[x], -1);
        updateM(x, poz[x], -1);
        int rez = querym(x, poz[x]) + queryM(x, poz[x]);
        total -= rez;
        cout << total << "\n";
    }
    return 0;
}
