#ifndef LOCAL
#include "guess.h"
#endif // LOCAL

#ifdef LOCAL
bool smaller(int);
#endif // LOCAL

int find_number(int MAX) {
    int l = 2, r = MAX;
    int largest = 2e9;
    while(l < r) {
        int mid = (l + r) / 2;
        if(smaller(mid)) {
            largest = mid;
            r = mid - 1;
        }
        else {
            l = mid + 1;
        }
    }
    return largest - 1;
}

#ifdef LOCAL
#include<iostream>
using namespace std;
static int n;
bool smaller (int x) {
    if (n<x) return true;
    return false;
}
int main () {
    int MAX,res;
    cin >> MAX >> n ;
    res=find_number(MAX);
    cout << res ;
    cout << endl ;
    return 0;
}
#endif // LOCAL
