#include <bits/stdc++.h>
#define MN 100071

using namespace std;
using ll = long long;
ll n, T[MN], V[MN];
using ii = pair<ll, ll>;

ll Delta[MN];

struct AIB {
	ll P[MN];
	stack<ll> U;
	void update(ll p, ll v) {
		++p;
		while(p < MN) {
			P[p] += v;
			U.push(p);
			p += p & -p;
		}
	}
	void clear() {
		while(!U.empty()) {
			P[U.top()] = 0;
			U.pop();
		}
	}
	ll q(ll p) {
		++p;
		ll re = 0;
		while(p) {
			re += P[p];
			p -= p & -p;
		}
		return re;
	}
	ll query(ll st, ll dr) {
		if(!st) return q(dr);
		return q(dr) - q(st - 1);
	}
} A1, A2;

ii A[MN], Tmp[MN];
void solve(ll st, ll dr) {
	if(st == dr) return;
	ll mij = (st + dr) >> 1;
	solve(st, mij);
	solve(mij + 1, dr);
	A1.clear();
	A2.clear();
	ll p1 = st, p2 = mij + 1, p3 = st;
	for(ll j = p1; j <= mij; ++j)
		A1.update(A[j].second, 1);
	while(p1 <= mij && p2 <= dr) {
		if(A[p1].first < A[p2].first) {
			Delta[A[p1].second] += A2.query(A[p1].second + 1, n);
			A1.update(A[p1].second, -1);
			Tmp[p3++] = A[p1++];
		} else {
			Delta[A[p2].second] += A1.query(A[p2].second + 1, n);
			A2.update(A[p2].second, 1);
			Tmp[p3++] = A[p2++];
		}
	}
	while(p1 <= mij) {
		Delta[A[p1].second] += A2.query(A[p1].second + 1, n);
		A1.update(A[p1].second, -1);
		Tmp[p3++] = A[p1++];
	}
	while(p2 <= dr) {
		Delta[A[p2].second] += A1.query(A[p2].second + 1, n);
		A2.update(A[p2].second, 1);
		Tmp[p3++] = A[p2++];
	}
	for(ll i = st; i <= dr; ++i)
		A[i] = Tmp[i];
}

int main() {
	cin >> n;
	for(ll i = 1; i <= n; ++i)
		cin >> V[i], T[i] = n;
	for(ll i = 1; i < n - 1; ++i) {
		ll v;
		cin >> v;
		T[v] = i + 1;
	}
	for(ll i = 1; i <= n; ++i)
		A[i] = {V[i], T[V[i]]};
	solve(1, n);
	for(ll i = 1; i <= n; ++i)
		Delta[0] += Delta[i];
	ll re = Delta[0];
	for(ll i = 2; i <= n; ++i) {
		cout << re << " ";
		re -= Delta[i];
	}
	return 0;
}
