#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2,bmi")

#define MN 100021

using namespace std;
using ll = long long;
int n, T[MN], V[MN];
using ii = pair<int, int>;

ll Delta[MN];

struct AIB {
	int P[MN];
	void update(int p, int v) {
		while(p < MN) {
			P[p] += v;
			p += p & -p;
		}
	}
	int q(int p) {
		int re = 0;
		while(p) {
			re += P[p];
			p -= p & -p;
		}
		return re;
	}
	int query(int st, int dr) {
		if(st > dr) return 0;
		if(!st) return q(dr);
		return q(dr) - q(st - 1);
	}
} A1, A2;

ii A[MN], Tmp[MN];
void solve(int st, int dr) {
	if(st == dr) return;
	int mij = (st + dr) >> 1;
	solve(st, mij);
	solve(mij + 1, dr);
	int p1 = st, p2 = mij + 1, p3 = st;
	for(int j = p1; j <= mij; ++j)
		A1.update(A[j].second, 1);
	while(p1 <= mij && p2 <= dr) {
		if(A[p1].first < A[p2].first) {
			Delta[A[p1].second] += A2.query(A[p1].second + 1, n);
			A1.update(A[p1].second, -1);
			Tmp[p3++] = A[p1++];
		} else {
			Delta[A[p2].second] += A1.query(A[p2].second, n);
			A2.update(A[p2].second, 1);
			Tmp[p3++] = A[p2++];
		}
	}
	while(p1 <= mij) {
		Delta[A[p1].second] += A2.query(A[p1].second + 1, n);
		A1.update(A[p1].second, -1);
		Tmp[p3++] = A[p1++];
	}
	while(p2 <= dr) {
		Delta[A[p2].second] += A1.query(A[p2].second, n);
		A2.update(A[p2].second, 1);
		Tmp[p3++] = A[p2++];
	}
	for(int i = mij + 1; i <= dr; ++i)
		A2.update(A[i].second, -1);
	for(int i = st; i <= dr; ++i)
		A[i] = Tmp[i];
}

int main() {
	cin >> n;
	for(int i = 1; i <= n; ++i)
		cin >> V[i], T[i] = n;
	for(int i = 1; i < n - 1; ++i) {
		int v;
		cin >> v;
		T[v] = i + 1;
	}
	for(int i = 1; i <= n; ++i)
		A[i] = {V[i], T[V[i]]};
	solve(1, n);
	for(int i = 1; i <= n; ++i)
		Delta[0] += Delta[i];
	ll re = Delta[0];
	for(int i = 2; i <= n; ++i) {
		cout << re << " ";
		re -= Delta[i];
	}
	return 0;
}
