#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

template<typename T> 
void print(vector<T> v) 
{
	cout << " ---> ";
	for (auto &x : v)
	{
		cout << x << " ";
	}
	cout << "\n";
}

int main() 
{
#ifdef ONPC
	freopen ("in.txt", "r", stdin);
#endif 	

#ifndef ONPC
	ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#endif 

	int n;
	cin >> n;
	auto add1d = [&] (int i, int x, vector<int> &aib1d) 
	{	
		i++;
		while (i <= n) 
		{
			aib1d[i] += x;
			i += i & (-i);
		}
	};	
	auto get1d = [&] (int i, vector<int> &aib1d)
	{
		i++;
		int sol = 0;
		while (i)
		{
			sol += aib1d[i];
			i -= i & (-i);
		}
		return sol;
	};	
	vector<vector<int>> mf(n + 1);
	vector<int> aib1d(n + 1, 0), aib1d2(n + 1, 0);
	vector<int> a(n);
	vector<int> p(n);
	vector<int> cur(n, -1);
	vector<int> del(n - 2, -1);
	vector<bool> used(n, 0);

	for (int i = 0; i < n; i++) 
	{
		cin >> a[i];
		a[i]--;
		p[a[i]] = i;
	}	

	for (int i = 0; i < n - 2; i++)
	{
		cin >> del[i];
		del[i]--;
		used[del[i]] = 1;
	}

	for (int x = 0; x < n; x++) 
	{
		if (used[x] == 0)
		{
			del.push_back(x);
		}
	}
	for (int x = 0; x < n; x++) 
	{
		int p1 = n - 1 - p[x];
		int p2 = x;
		p1++;
		p2++;
		for (int i = p1; i <= n; i += i & (-i))
		{
			mf[i].push_back(p2);
		}
	}
	for (int i = 1; i <= n; i++) 
	{
		sort(mf[i].begin(), mf[i].end());
		mf[i].resize(unique(mf[i].begin(), mf[i].end()) - mf[i].begin());
	}
	vector<vector<int>> aib(n + 1);
	for (int i = 1; i <= n; i++)
	{
		aib[i].resize((int) mf[i].size() + 1, 0);
	}
	auto add = [&] (int p1, int p2)
	{
		for (int i = p1; i <= n; i += i & (-i))
		{
			int pos = lower_bound(mf[i].begin(), mf[i].end(), p2) - mf[i].begin();
			assert(0 <= pos && pos < (int) mf[i].size());
			assert(mf[i][pos] == p2);
			for (int j = pos + 1; j <= (int) mf[i].size(); j += j & (-j)) 
			{
				aib[i][j]++;
			}
		}
	};
	auto get = [&] (int p1, int p2) 
	{
		int sol = 0;
		for (int i = p1; i; i -= i & (-i))
		{
			int cnt = 0, l = 0, r = (int) mf[i].size() - 1;
			while (l <= r) 
			{	
				int m = (l + r) / 2;
				if (mf[i][m] <= p2)
				{
					cnt = m + 1;
					l = m + 1;
				}	
				else
				{
					r = m - 1;
				}
			}
			for (int j = cnt; j; j -= j & (-j)) 
			{
				sol += aib[i][j];
			}
		}
		return sol;
	};
	reverse(del.begin(), del.end());
	vector<ll> sol(n, 0);
	ll current = 0;
	for (int step = 0; step < n; step++) 
	{
		int x = del[step];
		current += step - get1d(x, aib1d);
		add1d(x, +1, aib1d);
		add1d(p[x], +1, aib1d2);
		int cnt = 0;
		add(n - 1 - p[x] + 1, x + 1);	
		cnt = get(n - 1 - p[x] + 1, x + 1) - 1;
		current += 2 * cnt - (step - get1d(p[x], aib1d2) + 1);
		cur[n - 1 - p[x]] = x;
		sol[step] = current;
	}
	for (int i = n - 1; i >= 1; i--)
	{
		cout << sol[i] << " ";
	}
	cout << "\n";
	//print(del);
	
}
