#include <bits/stdc++.h>

using namespace std;

const int nmax = 1e3;

int n;

int v[nmax + 5];
int aux[nmax + 5];

int t[nmax + 5];

int rez[nmax + 5];

struct arbore_indexat_binar
{
private:
    int aib[nmax + 5];
    int ub(int x)
    {
        return (x & (-x));
    }
public:
    void update(int poz, int val)
    {
        for(int i=poz; i<=n; i+=ub(i))
        {
            aib[i] += val;
        }
    }
    int query(int qa, int qb)
    {
        int rez = 0;
        for(int i=qb; i>=1; i-=ub(i))
        {
            rez += aib[i];
        }
        for(int i=qa-1; i>=1; i-=ub(i))
        {
            rez -= aib[i];
        }
        return rez;
    }
};

arbore_indexat_binar aibst,aibdr;

void divide(int st, int dr)
{
    if(st==dr)
    {
        return;
    }
    int mij = (st + dr) >> 1;
    divide(st,mij);
    divide(mij+1,dr);
    int pozst = st;
    int pozdr = mij+1;
    int poz = st - 1;
    for(int i=st; i<=mij; i++)
    {
        aibst.update(t[v[i]],+1);
    }
    while(pozst<=mij && pozdr<=dr)
    {
        if(v[pozst]<v[pozdr])
        {
            int val = aibdr.query(t[v[pozst]],n);
            rez[0] += val;
            rez[t[v[pozst]]] -= val;
            aibst.update(t[v[pozst]],-1);
            aux[++poz] = v[pozst++];
        }
        else
        {
            int val = aibst.query(t[v[pozdr]],n);
            rez[0] += val;
            rez[t[v[pozdr]]] -= val;
            aibdr.update(t[v[pozdr]],+1);
            aux[++poz] = v[pozdr++];
        }
    }
    while(pozst<=mij)
    {
        int val = aibdr.query(t[v[pozst]],n);
        rez[0] += val;
        rez[t[v[pozst]]] -= val;
        aibst.update(t[v[pozst]],-1);
        aux[++poz] = v[pozst++];
    }
    while(pozdr<=dr)
    {
        aux[++poz] = v[pozdr++];
        aibdr.update(t[v[pozdr]],+1);
    }
    for(int i=mij+1; i<=dr; i++)
    {
        aibdr.update(t[v[i]],-1);
    }
    for(int i=st; i<=dr; i++)
    {
        v[i] = aux[i];
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin>>n;
    for(int i=1; i<=n; i++)
    {
        cin>>v[i];
    }
    for(int i=1; i<=n-2; i++)
    {
        int val;
        cin>>val;
        t[val] = i;
    }
    for(int i=1; i<=n; i++)
    {
        if(!t[i])
        {
            t[i] = n;
        }
    }
    divide(1,n);
    for(int i=1; i<=n; i++)
    {
        rez[i] += rez[i - 1];
    }
    for(int i=0; i<=n-2; i++)
    {
        cout<<rez[i]<<' ';
    }
    return 0;
}
