#include <bits/stdc++.h>
#define ub(x) (x&(-x))

using namespace std;

typedef long long LL;
constexpr int NMAX = 100005;

int N;
int A[NMAX];
int when[NMAX];

int cop[NMAX];

int scad[NMAX];

int aib[NMAX];
void Update (int pos, int val) {
    for (int i = pos; i ; i -= ub(i))
        aib[i] += val;
}
int Query (int pos) {
    int S = 0;
    for (int i = pos; i <= N; i += ub(i))
        S += aib[i];

    return S;
}

void Read() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> N;

    for (int i = 1; i <= N; ++ i )
        cin >> A[i];

    for (int i = 1; i <= N; ++ i )
        when[i] = N;

    for (int i = 1; i <= N-2; ++ i ) {
        int x;
        cin >> x;

        when[x] = i;
    }
}

LL cnt_i = 0;

void Solve (int st, int dr) {
    if (st == dr) return;

    int mij = (st + dr) / 2;

    Solve(st, mij);
    Solve(mij+1, dr);

    int ind = st;
    vector <int> sorted;
    for (int i = mij+1; i <= dr; ++ i ) {
        while (ind <= mij && A[ind] < A[i]) {
            sorted.push_back(A[ind]);
            ++ ind;
        }

        cnt_i += 1LL * (mij - ind + 1);
        sorted.push_back(A[i]);
    }
    while (ind <= dr)
        sorted.push_back(A[ind++]);

    for (int i = st; i <= mij; ++ i )
        Update(when[A[i]], 1);
    ind = st;
    for (int i = mij+1; i <= dr; ++ i ) {
        while (ind <= mij && A[ind] < A[i]) {
            Update(when[A[ind]], -1);
            ++ ind;
        }

        scad[when[A[i]]] += Query(when[A[i]]);
    }
    for (int i = ind; i <= mij; ++ i )
        Update(when[A[i]], -1);

    ind = mij+1;
    for (int i = st; i <= mij; ++ i ) {
        while (ind <= dr && A[ind] < A[i]) {
            Update(when[A[ind]], 1);
            ++ ind;
        }

        scad[when[A[i]]] += Query(when[A[i]]);
    }
    for (int i = mij+1; i < ind; ++ i )
        Update(when[A[i]], -1);

    for (int i = st; i <= dr; ++ i )
        A[i] = sorted[i - st];
}

void Afis () {
    cout << cnt_i << " ";
    for (int i = 1; i <= N-2; ++ i ) {
        cnt_i -= 1LL * scad[i];
        cout << cnt_i << " ";
    }
}

int main()
{
    Read();
    Solve(1, N);
    Afis();

    return 0;
}
