#include <bits/stdc++.h>

using namespace std;

const int N = 100005;
const int M = 162 * N;

int n, root, ls[M], rs[M], st[M], tsz, id[M], a[N], pos[N];

int Get1d(int v, int l, int r, int ll, int rr) {
  if (!v || l > r || l > rr || r < ll) return 0;
  if (ll <= l && r <= rr) return st[v];
  int mid = l + r >> 1;
  return Get1d(ls[v], l, mid, ll, rr) + Get1d(rs[v], mid + 1, r, ll, rr);
}

int Get2d(int v, int l, int r, int ll, int rr, int ql, int qr) {
  if (!v || l > r || l > rr || r < ll) return 0;
  if (ll <= l && r <= rr) return Get1d(id[v], 0, n - 1, ql, qr);
  int mid = l + r >> 1;
  return Get2d(ls[v], l, mid, ll, rr, ql, qr) + Get2d(rs[v], mid + 1, r, ll, rr, ql, qr);
}

void Update1d(int& v, int l, int r, int x, int val) {
  if (!v) v = ++tsz;
  st[v] += val;
  if (l == r) {
    return;
  }
  int mid = l + r >> 1;
  if (x <= mid) {
    Update1d(ls[v], l, mid, x, val);
  } else {
    Update1d(rs[v], mid + 1, r, x, val);
  }
}

void Update2d(int& v, int l, int r, int x, int y, int val) {
  if (!v) v = ++tsz;
  Update1d(id[v], 0, n - 1, y, val);
  if (l == r) {
    return;
  }
  int mid = l + r >> 1;
  if (x <= mid) {
    Update2d(ls[v], l, mid, x, y, val);
  } else {
    Update2d(rs[v], mid + 1, r, x, y, val);
  }
}
int readint(){
	int x=0,f=1; char ch=getchar();
	while(ch<'0'||ch>'9'){if(ch=='-')f=-1;ch=getchar();}
	while(ch>='0'&&ch<='9'){x=x*10+ch-'0';ch=getchar();}
	return x*f;
}


int main() {
  n = readint();
  for (int i = 0; i < n; i++) {
    a[i] = readint();
    --a[i];
    pos[a[i]] = i;
  }
  long long ans = 0;
  {
    vector<int> fenw(n + 1);
    auto Modify = [&](int x) {
      for (x++; x <= n; x += x & -x) {
        fenw[x] += 1;
      }
    };
    auto Query = [&](int x) {
      int res = 0;
      for (x++; x >= 1; x -= x & -x) {
        res += fenw[x];
      }
      return res;
    };
    for (int i = n - 1; i >= 0; i--) {
      ans += Query(a[i]);
      Modify(a[i]);
    }
    printf("%lld ", ans);
  }
  for (int i = 0; i < n; i++) {
    Update2d(root, 0, n - 1, i, a[i], +1);
  }
  for (int i = 0; i < n - 2; i++) {
    int x = readint();
    --x;
    if (pos[x] > 0) {
      ans -= Get2d(root, 0, n - 1, 0, pos[x] - 1, x, n - 1);
    }
    if (pos[x] + 1 < n) {
      ans -= Get2d(root, 0, n - 1, pos[x] + 1, n - 1, 0, x);
    }
    Update2d(root, 0, n - 1, pos[x], x, -1);
    printf("%lld ", ans);
  }
  return 0;
}
