#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

int main() {
	cin.tie(NULL);
	cout.tie(NULL);
	
	int n;
	cin >> n;
	
	vector<int> a(n);
	for (int i=0; i<n; i++) cin >> a[i];
	
	set<pair<int, int>> pairs;
	
	for (int i=0; i<n-1; i++) {
		for (int j=i+1; j<n; j++) {
			if (a[i] > a[j]) pairs.insert({a[i], a[j]});
		}
	}
	
	cout << pairs.size() << " ";
	
	for (int i=0; i<n-2; i++) {
		int ai;
		cin >> ai;
		
		for (auto it = pairs.begin(); it != pairs.end(); ) {
			pair<int, int> p = *it;
			if (ai == p.first || ai == p.second) it = pairs.erase(it);
			else ++it;
		}
		
		cout << pairs.size() << " ";
	}
}

