#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define all(c) c.begin(),c.end()
#define sz(c) (int)c.size()
#define f first
#define s second

// This is kinda like dp maybe?
// need to cater for the dynamic updates
// can think of an easy O(n^2) solution that won't get full marks
// It won't as mxN = 1e5
// However a good O(n^2) solution would get 85% I think
// need to update the ones behind and ahead
// use a segment tree?
// can efficiently get the number larger ahead and lower behind
// unsure how to cope with updates though
// I will try to implement an O(n^2) solution for now I think
// this will get me some partial points
// if we have sets for before and after we can find the number?
// This current one might be O(n^3)
// store for every element the ones above greater and below lower
// then go and remove them all for O(n^2) I think
// This will only work for up to 15000, not the last case

const ll mxN = 15000;
ll v[mxN][mxN];
ll tot[mxN];

void solve() {
	ll n;
	cin >> n;
	vector<ll> a(n), b(n-2);
	map<ll,ll> m;
	for (ll i = 0; i < n; i++) {
		cin >> a[i]; a[i]--;
		m[a[i]] = i;
	}
	for (ll i = 0; i < n-2; i++) {
		cin >> b[i]; b[i]--;
		b[i] = m[b[i]];
	}

	for (ll i = 0; i < n; i++) {
		for (ll j = 0; j < n; j++) {
			if (a[j] > a[i] && j < i) {
				v[i][j] = 1;
				tot[i]++;
			} else if (a[j] < a[i] && j > i) {
				v[i][j] = 1;
				tot[i]++;
			}
		}
	}

	ll out = 0;
	for (ll i = 0; i < n; i++)
		out += tot[i];

	cout << out/2 << " ";

	for (ll i = 0; i < sz(b); i++) {
		out -= tot[b[i]]*2;
		for (ll j = 0; j < n; j++) {
			if (v[j][b[i]]) {
				v[j][b[i]] = 0;
				tot[j]--;
			}
		}
		for (ll j = 0; j < n; j++)
			v[b[i]][j] = 0;
		tot[b[i]] = 0;

		cout << out/2 << (i == sz(b)-1 ? "" : " ");
	}
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);

	solve();
}
